<?php
	/*
		 _____  ____  _        ______
		|  __ \|  _ \| |      |  ____|
		| |  | | |_) | |      | |__ _ __ __ _ _ __   ___ ___
		| |  | |  _ <| |      |  __| '__/ _` | '_ \ / __/ _ \
		| |__| | |_) | |____  | |  | | | (_| | | | | (_|  __/
		|_____/|____/|______| |_|  |_|  \__,_|_| |_|\___\___|
     * Copyright
     * OVERRIDE POUR LE TEST DU CODE COUPON FFVE SERVICES
	 * Prestshop 8.x
    */    



	class CartController extends CartControllerCore
	{
		public function initContent()
		{
			parent::initContent();
			if (version_compare(_PS_VERSION_, '8.0.0', '<')) {
				return;
			}
			
			// Vérifier si un code de réduction est soumis
			if (Tools::isSubmit('addDiscount') && Tools::getValue('discount_name')) {
				$submittedCouponCode = Tools::getValue('discount_name');
				// Vérifiez si le coupon est valide
				$cartRuleId = CartRule::getIdByCode($submittedCouponCode);
				if (!$cartRuleId) {
					// Le coupon est invalide, vous pouvez ajouter une action spécifique ici
					if ( _FFVE_SERVICES_DEBUG_ )
					error_log('FFVE: Coupon invalide');
					// Appeler la méthode pour vérifier et appliquer le coupon FFVE local
					$this->applyFfveCoupon($submittedCouponCode);
					} else {
					if ( _FFVE_SERVICES_DEBUG_ )
					error_log('NORMAL: Coupon valide');
					//On exclu le CODE FFVE SERVICE
					if ( $submittedCouponCode == Configuration::get('FFVESERVICES_COUPON_CODE')){
					
					if ( _FFVE_SERVICES_DEBUG_ )
						error_log('CODE COUPON DIRECTEMENT APPELE : REFUS');
					
						$this->errors[] = 'Le code de réduction "' . $submittedCouponCode . '" ne peut pas être appliqué.';
						unset($_POST['discount_name']);
						unset($_GET['discount_name']);
						unset($_REQUEST['discount_name']);
						// Supprimer toute référence au coupon déjà appliqué dans le panier
						if ($cartRuleId) {
							$context = Context::getContext();
							$context->cart->removeCartRule($cartRuleId);
						}
					}
				}
			}
		}
		private function applyFfveCoupon($submittedCouponCode)
		{
			$couponCodeToApply = Configuration::get('FFVESERVICES_COUPON_CODE'); // Récupérer le coupon FFVE local stocké en configuration
			$context = Context::getContext();
			$settings = new FFVE_SETTINGS();
			if (empty($submittedCouponCode) || $submittedCouponCode == '') {
				if ( _FFVE_SERVICES_DEBUG_ )
				error_log('Code coupon non configué FFVE');
				return;
			}
			// Vérifiez si le coupon soumis est valide via l'API FFVE
			$ffveApi = new FFVE_API($settings->getServer(), $settings->getLogin(), $settings->getPassword());
			if (!empty($submittedCouponCode) && $ffveApi->checkCouponCodeExists($submittedCouponCode)) {
				// Vérifiez si le coupon local (FFVELOCAL) est déjà appliqué
				if ($context->cart->getOrderTotal() > 0 && !$this->isCouponApplied($context->cart, $couponCodeToApply)) {
					// Appliquer le coupon FFVE local
					$cartRuleId = CartRule::getIdByCode($couponCodeToApply);
					if ($cartRuleId) {
						$cartRule = new CartRule($cartRuleId);
						$resCoupon = $context->cart->addCartRule($cartRule->id);
						// Effacer les messages d'erreur existants et les messages de confirmation
					
						 
						 $context->controller->errors = array();
						$context->controller->confirmations = array();
						 
						
						// Recalculer les règles de panier
						$context->cart->getCartRules(true);
						// Enregistrer le code coupon soumis
						Context::getContext()->cookie->submittedCouponCode = FFVE_TOOLS::chiffrement($submittedCouponCode);
						if ( _FFVE_SERVICES_DEBUG_ )
						error_log('FFVE: Coupon FFVE local appliqué');
					}
					}else{
					if ( _FFVE_SERVICES_DEBUG_ )
					error_log('Coupon dejà appliqué ?');
					$context->controller->errors = array();
                    $context->controller->confirmations = array();
				}
				} else {
				if ( _FFVE_SERVICES_DEBUG_ )
				error_log('FFVE: Coupon soumis non valide via API');
			}
		} 
		/**
			* Check if a specific coupon is applied to the cart.
			*
			* @param Cart $cart
			* @param string $couponCode
			* @return bool
		*/
		private function isCouponApplied($cart, $couponCode)
		{
			foreach ($cart->getCartRules() as $cartRule) {
				if ($cartRule['code'] === $couponCode) {
					return true;
				}
			}
			return false;
		}
	}	